var sharedata = {};
var dialogBox;
var shareicon = [];
var sharetxt = [];

function web_share(data){

  sharedata = JSON.parse(data);
  if(sharedata.cacheimg){
      api.imageCache({
            url: sharedata.cacheimg
      }, function(ret, err) {
        if(ret.url){
         sharedata.cacheimg  = ret.url;
         //sharedata.cacheimg  = 'widget://images/logo.png';
         var file  =  Date.parse(new Date())+"shareimg.jpg";
         var imageFilter = api.require('imageFilter');
         imageFilter.compress({
                 img: sharedata.cacheimg,
                 quality: 0.6,
                 scale : 0.5 ,
                 save : {
                        album : false,
                        imgPath : api.cacheDir + "/temp/",
                        imgName : file
                 }
         }, function(ret, err){

            if( ret.status ){
                sharedata.cacheimg  = api.cacheDir + "/temp/"+file;
                doshare();
            }else{
               sharedata.cacheimg  = 'widget://images/logo.png';
               doshare();
            }

        });

        }else{
          sharedata.cacheimg  = 'widget://images/logo.png';
          doshare();
        }
      });
  }else{
      sharedata.cacheimg  = 'widget://images/logo.png';
      doshare();
  }

}

function doshare() {
  shareicon = [];
  sharetxt = [];
  var  wx = api.require('wx');
  var  qq = api.require('QQPlus');
    var weibo = api.require('weibo');
  wx.isInstalled(function(ret, err) {
     console_debug(ret,err);
     if (!ret.installed) {
       qq.installed(function(ret, err) {
          if (ret.status) {
              shareicon.push({text: 'QQ好友',icon: 'widget://image/share/qq.png'});
              shareicon.push({text: 'QQ空间',icon: 'widget://image/share/qzone.png'});
              sharetxt.push('QQ好友');
              sharetxt.push('QQ空间');
              weibo.isInstalled(function(ret, err) {
                 if (ret.status) {
                     shareicon.push({text: '微博',icon: 'widget://image/share/sina-weibo.png'});
                     sharetxt.push('微博');
                 }
                 share_dialog();
              });
          }else{
             weibo.isInstalled(function(ret, err) {
               if (ret.status) {
                   shareicon.push({text: '微博',icon: 'widget://image/share/sina-weibo.png'});
                   sharetxt.push('微博');
               }
               share_dialog();
             });
          }
          //share_dialog();
       });  
     }else{
       shareicon.push({text: '微信好友',icon: 'widget://image/share/wx.png'});
       shareicon.push({text: '朋友圈',icon: 'widget://image/share/wx-circle.png'});
       sharetxt.push('微信好友');
       sharetxt.push('朋友圈');
       qq.installed(function(ret, err) {
          if (ret.status) {
              shareicon.push({text: 'QQ好友',icon: 'widget://image/share/qq.png'});
              shareicon.push({text: 'QQ空间',icon: 'widget://image/share/qzone.png'});
              sharetxt.push('QQ好友');
              sharetxt.push('QQ空间');

              weibo.isInstalled(function(ret, err) {
                 if (ret.status) {
                     shareicon.push({text: '微博',icon: 'widget://image/share/sina-weibo.png'});
                     sharetxt.push('微博');
                 }
                 share_dialog();
              });
          }else{
              weibo.isInstalled(function(ret, err) {
              if (ret.status) {
                  shareicon.push({text: '微博',icon: 'widget://image/share/sina-weibo.png'});
                  sharetxt.push('微博');
              }
              share_dialog();
            });
          }
          //share_dialog();
       });
     }
  });




}


function share_dialog(){

  if(shareicon.length == 0){
      var clipBoard = api.require('clipBoard');
      clipBoard.set({value: sharedata.url}, function(ret, err) {
          if (ret) {
                api.toast({msg :'分享链接已复制到粘贴版',location: 'middle'});
              } else {

             }
       });
      return;
  }

  dialogBox = api.require('dialogBox');
  dialogBox.actionMenu({
            rect:{h:190},
            texts:{cancel:'取消'},
     items: shareicon,
          styles: {
             bg: '#f2f2f2',
             corner: 6,
             column: shareicon.length,
             itemText: {color: '#666',size: 14,marginT: 10},
             itemIcon: {size: 48},
             cancel: {bg: '#fff',color: '#666',h: 55,size: 14}
         },
      isCuttingLine:false,
      tapClose: true
  }, function(ret){

      if(ret.eventType=='cancel'){
          dialogBox.close({dialogName:'actionMenu'});
      } else if(ret.eventType=='click'){

        if(sharetxt[ret.index] == '微信好友'){
          wxshare('session');
        }
        if(sharetxt[ret.index] == '朋友圈'){
          wxshare('timeline');
        }
        if(sharetxt[ret.index] == 'QQ好友'){
          qqshare('QFriend');
        }
        if(sharetxt[ret.index] == 'QQ空间'){
          qqshare('QZone');
        }
        if(sharetxt[ret.index] == '微博'){
          weiboshare();
        }

      }
  });
}


function weiboshare(){

var weibo = api.require('weibo');
weibo.isInstalled(
    function(ret) {
        if (ret.status) {

weibo.shareWebPage({
    text: sharedata.text,
    title: sharedata.title,
    description: sharedata.text,
    thumb: sharedata.cacheimg,
    contentUrl: sharedata.url
}, function(ret, err) {
     dialogBox.close({dialogName: 'actionMenu'});
    if (ret.status) {
        //alert('分享成功');
        api.toast({msg : '分享成功！',location: 'middle'});
    }
});

        } else {
            alert('未安装新浪微博客户端');
        }
    }
);

}


function wxshare(wxscene){

var wx = api.require('wx');



wx.isInstalled(function(ret, err) {
 if (ret.installed) {



//  cacheimg = '';
console_debug(sharedata,'');
 wx.shareWebpage({
      apiKey: 'wxb32a8e5b85f55bae',
      scene: wxscene,
      title: sharedata.title,
      description: sharedata.text,
      thumb: sharedata.cacheimg,
      contentUrl: sharedata.url
 }, function(ret, err) {
    //api.hideProgress();
    dialogBox.close({dialogName: 'actionMenu'});
    if (ret.status) {
       api.toast({msg : '分享成功！',location: 'middle'});
    } else {
       alert('错误代码'+err.code);
    }

 });



 } else {
     alert('当前设备未安装微信客户端');
 }
});

}


function qqshare(ptype){

var  qq = api.require('QQPlus');
qq.installed(function(ret, err) {

 if (ret.status) {
//api.showProgress({title:"提示!",text:"分享中..."});
qq.shareNews({
 url: sharedata.url,
 title: sharedata.title,
 description: sharedata.text,
 type:ptype ,
 imgUrl: sharedata.cacheimg
}, function(ret, err) {
  //api.hideProgress();
  //api.alert({msg:JSON.stringify(ret)});
  //api.alert({msg:JSON.stringify(err)});
  dialogBox.close({dialogName: 'actionMenu'});
 if (ret.status) {
     api.toast({msg : '分享成功！',location: 'middle'});
    //dosomething
 }
});


 } else {
     api.alert({ msg: "没有安装QQ" });
 }

});

}
